diff --git a/Plugins/DbAndroid/dbandroidinstance.cpp b/Plugins/DbAndroid/dbandroidinstance.cpp
index 900b92992d..7dce61c7f7 100644
--- a/Plugins/DbAndroid/dbandroidinstance.cpp
+++ b/Plugins/DbAndroid/dbandroidinstance.cpp
@@ -10,6 +10,7 @@
 #include "schemaresolver.h"
 #include "services/notifymanager.h"
 #include "db/dbsqlite3.h"
+#include "parser/parser.h"
 #include <QJsonObject>
 #include <QJsonArray>
 #include <QJsonDocument>
@@ -26,6 +27,37 @@ DbAndroidInstance::~DbAndroidInstance()
     closeInternal();
 }
 
+QList<AliasedColumn> DbAndroidInstance::columnsForQuery(const QString& query)
+{
+    Parser parser;
+    bool res = parser.parse(query);
+    if (!res)
+    {
+        qWarning() << "Could not parse query for providing columnsForQuery from DbAndroid:" << query;
+        return QList<AliasedColumn>();
+    }
+
+    if (!isDataReturningQuery(parser.getQueries().last()->queryType))
+        return QList<AliasedColumn>();
+
+    SqlQueryPtr results = exec(query);
+    if (results->isError())
+    {
+        qWarning() << "Could not execute query for providing columnsForQuery from DbAndroid:" << query
+                   << ". The error was:" << results->getErrorText();
+        return QList<AliasedColumn>();
+    }
+
+    QList<AliasedColumn> columns;
+    AliasedColumn column;
+    for (const QString& colName : results->getColumnNames())
+    {
+        column.setAlias(colName);
+        columns << column;
+    }
+    return columns;
+}
+
 SqlQueryPtr DbAndroidInstance::prepare(const QString& query)
 {
     return SqlQueryPtr(new SqlQueryAndroid(this, connection, query));
diff --git a/Plugins/DbAndroid/dbandroidinstance.h b/Plugins/DbAndroid/dbandroidinstance.h
index 157caae0a0..5ddbd85325 100644
--- a/Plugins/DbAndroid/dbandroidinstance.h
+++ b/Plugins/DbAndroid/dbandroidinstance.h
@@ -19,6 +19,7 @@ class DbAndroidInstance : public AbstractDb
         DbAndroidInstance(DbAndroid* plugin, const QString& name, const QString& path, const QHash<QString, QVariant>& connOptions);
         ~DbAndroidInstance();
 
+        QList<AliasedColumn> columnsForQuery(const QString& query);
         SqlQueryPtr prepare(const QString& query);
         QString getTypeLabel();
         bool deregisterFunction(const QString& name, int argCount);
diff --git a/SQLiteStudio3/coreSQLiteStudio/parser/ast/sqlitequerytype.cpp b/SQLiteStudio3/coreSQLiteStudio/parser/ast/sqlitequerytype.cpp
index 6697b4a78e..1c04ca6d01 100644
--- a/SQLiteStudio3/coreSQLiteStudio/parser/ast/sqlitequerytype.cpp
+++ b/SQLiteStudio3/coreSQLiteStudio/parser/ast/sqlitequerytype.cpp
@@ -64,3 +64,41 @@ QString sqliteQueryTypeToString(const SqliteQueryType& type)
             return QString();
     }
 }
+
+bool isDataReturningQuery(const SqliteQueryType& type)
+{
+    switch (type)
+    {
+        case SqliteQueryType::Select:
+        case SqliteQueryType::Pragma:
+            return true;
+        case SqliteQueryType::UNDEFINED:
+        case SqliteQueryType::EMPTY:
+        case SqliteQueryType::AlterTable:
+        case SqliteQueryType::Analyze:
+        case SqliteQueryType::Attach:
+        case SqliteQueryType::BeginTrans:
+        case SqliteQueryType::CommitTrans:
+        case SqliteQueryType::Copy:
+        case SqliteQueryType::CreateIndex:
+        case SqliteQueryType::CreateTable:
+        case SqliteQueryType::CreateTrigger:
+        case SqliteQueryType::CreateView:
+        case SqliteQueryType::CreateVirtualTable:
+        case SqliteQueryType::Delete:
+        case SqliteQueryType::Detach:
+        case SqliteQueryType::DropIndex:
+        case SqliteQueryType::DropTable:
+        case SqliteQueryType::DropTrigger:
+        case SqliteQueryType::DropView:
+        case SqliteQueryType::Insert:
+        case SqliteQueryType::Reindex:
+        case SqliteQueryType::Release:
+        case SqliteQueryType::Rollback:
+        case SqliteQueryType::Savepoint:
+        case SqliteQueryType::Update:
+        case SqliteQueryType::Vacuum:
+        default:
+            return false;
+    }
+}
diff --git a/SQLiteStudio3/coreSQLiteStudio/parser/ast/sqlitequerytype.h b/SQLiteStudio3/coreSQLiteStudio/parser/ast/sqlitequerytype.h
index 763fcfafb3..9326bf48d2 100644
--- a/SQLiteStudio3/coreSQLiteStudio/parser/ast/sqlitequerytype.h
+++ b/SQLiteStudio3/coreSQLiteStudio/parser/ast/sqlitequerytype.h
@@ -37,5 +37,6 @@ enum class SqliteQueryType
 };
 
 QString API_EXPORT sqliteQueryTypeToString(const SqliteQueryType& type);
+bool API_EXPORT isDataReturningQuery(const SqliteQueryType& type);
 
 #endif // SQLITEQUERYTYPE_H
